質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

87.49%

python株テクニカル指標のグラフ化について

解決済

回答 1

投稿

  • 評価
  • クリップ 0
  • VIEW 454

score 20

移動平均、出来高、MACD、RSIの4つのグラフを出力したいのですが、エラー文と共に最後のRSIのみグラフが出てきません。エラー文もよくわからないので、どうしたらよいでしょうか。

import pandas as pd
import numpy as np
import talib as ta
from pandas_datareader import data
import matplotlib.pyplot as plt
%matplotlib inline

start = '2019-11-01'
end = '2020-11-01'
df = data.DataReader('^N225', 'yahoo', start, end)

date = df.index
close = df['Adj Close']
df['macd'], df['macdsignal'], df['macdhist'] = ta.MACD(close, fastperiod=12, slowperiod=26, signalperiod=9)
df['RSI'] = ta.RSI(close, timeperiod=span02)

span01 = 5
span02 = 25
span03 = 50

df['mov01'] = close.rolling(window=span01).mean()
df['mov02'] = close.rolling(window=span02).mean()
df['mov03'] = close.rolling(window=span03).mean()

plt.figure(figsize=(30,10))
plt.subplot(4,1,1) #移動平均

plt.plot(date,close,label='Close')
plt.plot(date, df['mov01'],label='mov01')
plt.plot(date, df['mov02'],label='mov02')
plt.plot(date, df['mov03'],label='mov03')
plt.legend()

plt.subplot(4,1,2) #出来高
plt.bar(date, df['Volume'], label='Volume')
plt.legend()

plt.subplot(4,1,3) #MACD
plt.fill_between(date, df['macdhist'], alpha=0.5, label='MACD_hist')
plt.hlines(0, start, end, 'gray', linestyle='dashed')
plt.legend()

plt.subplot(4,1,4) #RSI
plt.plot(date, df['RSI'], label='RSI')
plt.ylim(0,100)
plt.hlines([30,50,70], start, end, 'gray', linestyles='dashed')
plt.legend()

エラー文は以下です。

AttributeError                            Traceback (most recent call last)
~\Anaconda3\lib\site-packages\matplotlib\axis.py in convert_units(self, x)
   1549         try:
-> 1550             ret = self.converter.convert(x, self.units, self)
   1551         except Exception as e:

~\Anaconda3\lib\site-packages\matplotlib\dates.py in convert(value, unit, axis)
   2007         """
-> 2008         return date2num(value)
   2009 

~\Anaconda3\lib\site-packages\matplotlib\dates.py in date2num(d)
    425             return d
--> 426         return _to_ordinalf_np_vectorized(d)
    427 

~\Anaconda3\lib\site-packages\numpy\lib\function_base.py in __call__(self, *args, **kwargs)
   2107 
-> 2108         return self._vectorize_call(func=func, args=vargs)
   2109 

~\Anaconda3\lib\site-packages\numpy\lib\function_base.py in _vectorize_call(self, func, args)
   2185         else:
-> 2186             ufunc, otypes = self._get_ufunc_and_otypes(func=func, args=args)
   2187 

~\Anaconda3\lib\site-packages\numpy\lib\function_base.py in _get_ufunc_and_otypes(self, func, args)
   2145             inputs = [arg.flat[0] for arg in args]
-> 2146             outputs = func(*inputs)
   2147 

~\Anaconda3\lib\site-packages\matplotlib\dates.py in _to_ordinalf(dt)
    225 
--> 226     base = float(dt.toordinal())
    227 

AttributeError: 'numpy.str_' object has no attribute 'toordinal'

The above exception was the direct cause of the following exception:

ConversionError                           Traceback (most recent call last)
<ipython-input-11-21219a718bff> in <module>
     38 plt.subplot(4,1,3) #MACD
     39 plt.fill_between(date, df['macdhist'], alpha=0.5, label='MACD_hist')
---> 40 plt.hlines(0, start, end, 'gray', linestyle='dashed')
     41 plt.legend()
     42 

~\Anaconda3\lib\site-packages\matplotlib\pyplot.py in hlines(y, xmin, xmax, colors, linestyles, label, data, **kwargs)
   2664         y, xmin, xmax, colors=colors, linestyles=linestyles,
   2665         label=label, **({"data": data} if data is not None else {}),
-> 2666         **kwargs)
   2667 
   2668 

~\Anaconda3\lib\site-packages\matplotlib\__init__.py in inner(ax, data, *args, **kwargs)
   1599     def inner(ax, *args, data=None, **kwargs):
   1600         if data is None:
-> 1601             return func(ax, *map(sanitize_sequence, args), **kwargs)
   1602 
   1603         bound = new_sig.bind(ax, *args, **kwargs)

~\Anaconda3\lib\site-packages\matplotlib\axes\_axes.py in hlines(self, y, xmin, xmax, colors, linestyles, label, **kwargs)
   1098         self._process_unit_info([xmin, xmax], y, kwargs=kwargs)
   1099         y = self.convert_yunits(y)
-> 1100         xmin = self.convert_xunits(xmin)
   1101         xmax = self.convert_xunits(xmax)
   1102 

~\Anaconda3\lib\site-packages\matplotlib\artist.py in convert_xunits(self, x)
    178         if ax is None or ax.xaxis is None:
    179             return x
--> 180         return ax.xaxis.convert_units(x)
    181 
    182     def convert_yunits(self, y):

~\Anaconda3\lib\site-packages\matplotlib\axis.py in convert_units(self, x)
   1551         except Exception as e:
   1552             raise munits.ConversionError('Failed to convert value(s) to axis '
-> 1553                                          f'units: {x!r}') from e
   1554         return ret
   1555 

ConversionError: Failed to convert value(s) to axis units: '2019-11-01'
  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 1

checkベストアンサー

+1

エラーが出たらまずはそのままググることです。さっそくTeratailの以前のQAがヒットしました
https://teratail.com/questions/218687

plotする時にx軸が日付型を用いているのにstart, endが文字列だからエラーとなっています。

のでdatetimeを用いて例えば下記のように
またspan02の定義が

df['RSI'] = ta.RSI(close, timeperiod=span02)


の後になっていてここでエラーが出ます。そのため定義を前にしました。
で下記

import pandas as pd
import numpy as np
import talib as ta
from pandas_datareader import data
import matplotlib.pyplot as plt
%matplotlib inline
from datetime import datetime

start = '2019-11-01'
end = '2020-11-01'
df = data.DataReader('^N225', 'yahoo', start, end)

span01 = 5
span02 = 25
span03 = 50

date = df.index
close = df['Adj Close']
df['macd'], df['macdsignal'], df['macdhist'] = ta.MACD(close, fastperiod=12, slowperiod=26, signalperiod=9)
df['RSI'] = ta.RSI(close, timeperiod=span02)



df['mov01'] = close.rolling(window=span01).mean()
df['mov02'] = close.rolling(window=span02).mean()
df['mov03'] = close.rolling(window=span03).mean()

plt.figure(figsize=(30,10))
plt.subplot(4,1,1) #移動平均

plt.plot(date,close,label='Close')
plt.plot(date, df['mov01'],label='mov01')
plt.plot(date, df['mov02'],label='mov02')
plt.plot(date, df['mov03'],label='mov03')
plt.legend()

plt.subplot(4,1,2) #出来高
plt.bar(date, df['Volume'], label='Volume')
plt.legend()


plt.subplot(4,1,3) #MACD
plt.fill_between(date, df['macdhist'], alpha=0.5, label='MACD_hist')
plt.hlines(0, datetime.strptime(start, '%Y-%m-%d'), datetime.strptime(end, '%Y-%m-%d'), 'gray', linestyle='dashed')
plt.legend()

plt.subplot(4,1,4) #RSI
plt.plot(date, df['RSI'], label='RSI')
plt.ylim(0,100)
plt.hlines([30,50,70], datetime.strptime(start, '%Y-%m-%d'), datetime.strptime(end, '%Y-%m-%d'), 'gray', linestyles='dashed')
plt.legend()

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2020/11/07 15:34

    ありがとうございます! 定義の順序がそもそもおかしいことにも気づいておりませんでした((^^;))
    無事に出力もされました。ありがとうございます!

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 87.49%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

関連した質問

同じタグがついた質問を見る